function ssoServer(port,clientDomain,clientTokenName,caseDomain,ignoreCasPatten,APPLICATION_NAME,paltToken) {
  var express = require('express')
  var ConnectCas = require('./connect-cas2/index');
  var bodyParser = require('body-parser');
  var session = require('express-session');
  var cookieParser = require('cookie-parser');
  var MemoryStore = require('session-memory-store')(session);
  var app = express()
  app.use(cookieParser());
  app.use(session({
    name: 'NSESSIONID',
    secret: 'Hello I am a long long long secret',
    store: new MemoryStore(),  // or other session store
    resave:false,//强制保存session,即使它没变化
    saveUninitialized:true //强制将未初始化的session存储，默认为true
  }));
  var casClient = new ConnectCas({
    debug: true,
    ignore: [
      new RegExp(ignoreCasPatten)
    ],
    match: [],
    servicePrefix: clientDomain,
    serverPath: caseDomain,
    paths: {
      validate: '/cas/validate',
      serviceValidate: '/cas/p3/serviceValidate',
      proxy:'',
      proxyCallback:'',
      login: '/cas/login',
      logout: '/cas/logout',

    },

    rejectUnauthorized:false,
    restletIntegration:false,
    gateway: false,
    renew: false,
    slo: true,
    cache: {
      enable: false,
      ttl: 5 * 60 * 1000,
      filter: []
    },
    fromAjax: {
      header: 'x-client-ajax',
      status: 418
    }
  });
  app.use(casClient.core());
  app.use(bodyParser.json());
  app.use(bodyParser.urlencoded({ extended: true }));
  var http = require('http').Server(app)
  var path = require('path');
  let PublicPath = APPLICATION_NAME !== '*' ? '/' + APPLICATION_NAME : ''

  app.set('views', path.join(__dirname, '../../dist' + PublicPath));
  app.set('view engine', 'ejs');
  app.use(express.static(path.join(__dirname, '../../dist')));
  if(APPLICATION_NAME !== '*'){
    app.get('/', function(req, res, next) {
      res.redirect('/' + APPLICATION_NAME)
    })
  }
  app.get('/' + APPLICATION_NAME, function(req, res, next) {
    var regTest =  new RegExp(ignoreCasPatten);
    if(regTest.test(req.url)){
      res.sendFile(path.join(__dirname,'dist' + PublicPath + '/static/' + req.url),
        function (req1,res1) {
          if(req1 && req1.status === 404){
            res.send(JSON.stringify(req1))
          }
        })
    }else if(req.url !== '/logout'){
      var attributes = req.session.cas.attributes
      var TOKEN = ''
      console.log(paltToken)
      console.log(attributes[paltToken][0])
      if(attributes[paltToken] && attributes[paltToken][0]){
        TOKEN = attributes[paltToken][0]
      }else {
        throw Error('cas 授权登陆失败')
      }
      res.setHeader('Set-Cookie', clientTokenName + '=' + TOKEN );
      res.render('index')
    }else { //登出
      // Do whatever you like here, then call the logout middleware
      casClient.logout()(req, res, next);
    }
  })
  if (process.env.PORT) {
    console.log('> Listening at ' + process.env.PORT + '\n')
    http.listen(process.env.PORT)
  } else {
    http.listen(port)
    console.log('> Listening at ' + port + '\n')
  }
}
module.exports = ssoServer;
